; 20-21 sept 2009
; J-P Sutto & Franois Collard
; Last changed 2011/11/09 by Franois Collard (fix error messages in Gimp 2.7)
;(gimp-rect-select image x y width height operation feather feather-radius)
;=>(gimp-image-select-rectangle image operation x y width height)

(script-fu-register "JP-Borders"
    "<Image>/Filters/Decor/JP-Borders"
    "Creates a single or double image border with optional round corners"
    "(c) Jean-Pierre Sutto & Franois Collard"
    "Published under GPL version 2"
    "Septembre 2009"
    "*"
	SF-IMAGE		"Image" 0
	SF-TOGGLE 		_"_Round Corners..." TRUE
	SF-ADJUSTMENT 	_"Edge radius"     '(70 1 1024 1 10 0 0)
	SF-ADJUSTMENT 	_"Border size" '(50 0 1024 1 10 0 0)
	SF-COLOR      	_"Border color" '(0 0 0)
	SF-TOGGLE    	_"Inner border"  FALSE
	SF-ADJUSTMENT 	_"Inner border size" '(10 0 1024 1 10 0 0)
	SF-COLOR 		_"Inner border color" '(255 255 255)
	SF-TOGGLE    	_"Blur border"  TRUE
	SF-ADJUSTMENT 	_"Width"     '(3 0 1024 1 10 0 0)
	SF-ADJUSTMENT 	_"Blur radius"     '(2 0 1024 1 10 0 0)
)
(define
    (JP-Borders 	image
				round-corners
				rayon
				marge
				couleur
				inner-border
				inner-width
				inner-color
				blur-border
				tailleflou						
				flou
	)
(begin	
    ; dbut groupe d'annulation
(gimp-image-undo-group-start image)
(define premierplanorigine (car (gimp-context-get-foreground)))
(define arriereplanorigine (car (gimp-context-get-background)))

(define drawable(car (gimp-image-flatten image)))
(define largeur (car (gimp-image-width image)))
(define hauteur (car (gimp-image-height image)))

(if (= inner-border TRUE)
(begin
(define radius rayon)
(define color inner-color)
(define width inner-width)

(make-frame 	image
				round-corners
				radius
				width
				color
				inner-border
				blur-border
				tailleflou						
				flou
				largeur
				hauteur
				drawable
)
)
)
(define drawable(car (gimp-image-flatten image)))
(define largeur (car (gimp-image-width image)))
(define hauteur (car (gimp-image-height image)))
	
(define color couleur)
(define width marge)

(cond ((= inner-border FALSE) (define radius rayon)) (else (define radius (+ inner-width rayon))))

(make-frame 	image
				round-corners
				radius
				width
				color
				inner-border
				blur-border
				tailleflou						
				flou
				largeur
				hauteur
				drawable
)

    ; on dslectionne tout
    (gimp-selection-none image)

    ; rafraichissement de l'affichage
    (gimp-displays-flush)

    ; fin groupe d'annulation
    (gimp-context-set-foreground premierplanorigine)
    (gimp-context-set-background arriereplanorigine)
    (gimp-image-undo-group-end image)
)
)

(define
    (make-frame 	image
				round-corners
				radius
				width
				color
				inner-border
				blur-border
				tailleflou						
				flou
				largeur
				hauteur
				drawable
	)

    (begin
    ; on dslectionne tout au cas o
    (gimp-selection-none image)
	(gimp-context-set-background color)
	
    (if (= round-corners TRUE)
        (begin 
    ; on slectionne le rectangle arrondi
    (gimp-image-select-round-rectangle
        image
		CHANNEL-OP-ADD ; operation
        0 ; x
        0 ; y
        largeur ; width
        hauteur ; height
        radius ; corner-radius x
        radius ; corner-radius y
    )
    ; on inverse la slection
    (gimp-selection-invert image)
    ; on met la couleur de fond  la variable couleur
    (gimp-context-set-background color)
    ; on coupe, ce qui fait apparatre la couleur de fond
    (gimp-edit-cut drawable)
    ; on remet la slection  zro
    (gimp-selection-none image)
	)
	)
    ; on construit la marge
    ; on dfinit une nouvelle taille pour l'image
    (define newlargeur (+ (* 2 width) largeur))
    (define newhauteur (+ (* 2 width) hauteur))
    (define xoffset width)
    (define yoffset width)
    ; on construit la marge
    (gimp-image-resize image newlargeur newhauteur xoffset yoffset)
    ; on plaque le drawable sur l'image, ce qui fait apparatre la marge
    (gimp-layer-resize-to-image-size drawable)
    ; on slectionne la zone  flouter
    ; on reprend les nouvelles dim de l'image
	(define largeur (car (gimp-image-width image)))
	(define hauteur (car (gimp-image-height image)))
    ; on floute ou pas la bordure
    (if (and (= blur-border TRUE) (= round-corners TRUE))
        (begin
            ; on slectionne le rectangle arrondi extrieur
            (gimp-image-select-round-rectangle
                image
				CHANNEL-OP-ADD ; operation
                (- width tailleflou) ; x
                (- width tailleflou) ; y
                (- largeur (* 2 (- width tailleflou))) ; width
                (- hauteur (* 2 (- width tailleflou))) ; height
                radius ; corner-radius x
                radius ; corner-radius y
            )
            ; on slectionne le rectangle arrondi intrieur que l'on enlve
            ;  la prcdente slection
            (gimp-image-select-round-rectangle
                image
				CHANNEL-OP-SUBTRACT ; operation
                (+ width tailleflou) ; x
                (+ width tailleflou) ; y
                (- largeur (* 2 (+ width tailleflou))) ; width
                (- hauteur (* 2 (+ width tailleflou))) ; height
                radius ; corner-radius x
                radius ; corner-radius y
            )

            ; on floute la zone slectionne
            (plug-in-gauss
                1 ; run-mode
                image ; image
                drawable ; drawable
                flou ; horizontal radius
                flou ; vertical radius
                0 ; method
            )
        )
    )
	
	(define largeur (car (gimp-image-width image)))
	(define hauteur (car (gimp-image-height image)))
	
	(if (and (= blur-border TRUE) (= round-corners FALSE))
        (begin
            ; on slectionne le rectangle extrieur
            (gimp-image-select-rectangle
                image
                CHANNEL-OP-ADD ; operation				
                (- width tailleflou) ; x
                (- width tailleflou) ; y
                (- largeur (* 2 (- width tailleflou))) ; width
                (- hauteur (* 2 (- width tailleflou))) ; height
            )
            ; on slectionne le rectangle intrieur que l'on enlve
            ;  la prcdente slection
            (gimp-image-select-rectangle
                image
                CHANNEL-OP-SUBTRACT ; operation
                (+ width tailleflou) ; x
                (+ width tailleflou) ; y
                (- largeur (* 2 (+ width tailleflou))) ; width
                (- hauteur (* 2 (+ width tailleflou))) ; height
            )

            ; on floute la zone slectionne
            (plug-in-gauss
                1 ; run-mode
                image ; image
                drawable ; drawable
                flou ; horizontal radius
                flou ; vertical radius
                0 ; method
            )
        )
    )
	)
	)