; Last changed 2011/11/11 by Franois Collard (fix error messages in Gimp 2.7-2.8)
(script-fu-register
	"script-fu-unsharp-mask-multilayer"
	"Unsharp Mask Multilayer..."
	"Advanced sharpening based on USM"
	"Stefan Vladuck"
	"copyright 2008, Stefan Vladuck"
	"May 21, 2008"
	"RGB* GRAY*"
	SF-IMAGE	"Image"		0
	SF-DRAWABLE	"Drawable"	0
	SF-ADJUSTMENT "Highlight USM Radius" '(.3 .1 120 .1 1 1 0)
	SF-ADJUSTMENT "Highlight USM Amount" '(2 0 10 .01 .1 2 0)
	SF-ADJUSTMENT "Highlight USM Threshold" '(0 0 255 1 10 0 0)
	SF-ADJUSTMENT "Shadow USM Radius" '(.3 .1 120 .1 1 1 0)
	SF-ADJUSTMENT "Shadow USM Amount" '(2 0 10 .01 .1 2 0)
	SF-ADJUSTMENT "Shadow USM Threshold" '(0 0 255 1 10 0 0)
	SF-TOGGLE _"Flatten image" TRUE
)
(script-fu-menu-register "script-fu-unsharp-mask-multilayer" "<Image>/Filters/Enhance")
(define (script-fu-unsharp-mask-multilayer 
	image 
	drawable 
	light-radius 
	light-amount
	light-threshold
	dark-radius
	dark-amount
	dark-threshold
	flatten-image)
  (let* (
    (layer-light 0)
    (layer-dark 0)
    (layer-light-limit 0)
    (layer-dark-limit 0)
    (layer-temp 0)
    )
    (gimp-image-undo-group-start image)

    (set! layer-dark 
      (car 
        (gimp-layer-new-from-drawable drawable image)))
    (gimp-image-insert-layer image layer-dark 0 -1)
    (gimp-item-set-name layer-dark "Shadow sharpen")
    (plug-in-unsharp-mask 1 image layer-dark dark-radius dark-amount dark-threshold)
    (gimp-layer-set-mode layer-dark DARKEN-ONLY-MODE)

    (set! layer-light 
      (car 
        (gimp-layer-new-from-drawable drawable image)))
    (gimp-image-insert-layer image layer-light 0 -1)
    (gimp-item-set-name layer-light "Highlight sharpen")
    (plug-in-unsharp-mask 1 image layer-light light-radius light-amount light-threshold)
    (gimp-layer-set-mode layer-light LIGHTEN-ONLY-MODE)

    (set! layer-dark-limit
      (car
        (gimp-layer-new-from-drawable drawable image)))
    (gimp-image-insert-layer image layer-dark-limit 0 -1)
    (gimp-item-set-name layer-dark-limit "Shadow sharpen limit")
    (set! layer-temp
      (car
        (gimp-layer-new-from-drawable drawable image)))
    (gimp-image-insert-layer image layer-temp 0 -1)
    (gimp-layer-set-mode layer-temp DARKEN-ONLY-MODE)
    (gimp-drawable-offset layer-temp FALSE OFFSET-TRANSPARENT 1 0)
    (gimp-image-merge-down image layer-temp 1)
    (set! layer-temp
      (car
        (gimp-layer-new-from-drawable drawable image)))
    (gimp-image-insert-layer image layer-temp 0 -1)
    (gimp-layer-set-mode layer-temp DARKEN-ONLY-MODE)
    (gimp-drawable-offset layer-temp FALSE OFFSET-TRANSPARENT -1 0)
    (gimp-image-merge-down image layer-temp 1)
    (set! layer-temp
      (car
        (gimp-layer-new-from-drawable 
          (car (gimp-image-get-active-drawable image))
          image)))
    (gimp-image-insert-layer image layer-temp 0 -1)
    (gimp-layer-set-mode layer-temp DARKEN-ONLY-MODE)
    (gimp-drawable-offset layer-temp FALSE OFFSET-TRANSPARENT 0 1)
    (gimp-image-merge-down image layer-temp 1)
    (set! layer-temp
      (car
        (gimp-layer-new-from-drawable 
          (car (gimp-image-get-active-drawable image))
          image)))
    (gimp-image-insert-layer image layer-temp 0 -1)
    (gimp-layer-set-mode layer-temp DARKEN-ONLY-MODE)
    (gimp-drawable-offset layer-temp FALSE OFFSET-TRANSPARENT 0 -1)
    (gimp-image-merge-down image layer-temp 1)
    (gimp-layer-set-mode
      (car (gimp-image-get-active-drawable image))
      LIGHTEN-ONLY-MODE)

    (set! layer-light-limit
      (car
        (gimp-layer-new-from-drawable drawable image)))
    (gimp-image-insert-layer image layer-light-limit 0 -1)
    (gimp-item-set-name layer-light-limit "Highlight sharpen limit")
    (set! layer-temp
      (car
        (gimp-layer-new-from-drawable drawable image)))
    (gimp-image-insert-layer image layer-temp 0 -1)
    (gimp-layer-set-mode layer-temp LIGHTEN-ONLY-MODE)
    (gimp-drawable-offset layer-temp FALSE OFFSET-TRANSPARENT 1 0)
    (gimp-image-merge-down image layer-temp 1)
    (set! layer-temp
      (car
        (gimp-layer-new-from-drawable drawable image)))
    (gimp-image-insert-layer image layer-temp 0 -1)
    (gimp-layer-set-mode layer-temp LIGHTEN-ONLY-MODE)
    (gimp-drawable-offset layer-temp FALSE OFFSET-TRANSPARENT -1 0)
    (gimp-image-merge-down image layer-temp 1)
    (set! layer-temp
      (car
        (gimp-layer-new-from-drawable 
          (car (gimp-image-get-active-drawable image))
          image)))
    (gimp-image-insert-layer image layer-temp 0 -1)
    (gimp-layer-set-mode layer-temp LIGHTEN-ONLY-MODE)
    (gimp-drawable-offset layer-temp FALSE OFFSET-TRANSPARENT 0 1)
    (gimp-image-merge-down image layer-temp 1)
    (set! layer-temp
      (car
        (gimp-layer-new-from-drawable 
          (car (gimp-image-get-active-drawable image))
          image)))
    (gimp-image-insert-layer image layer-temp 0 -1)
    (gimp-layer-set-mode layer-temp LIGHTEN-ONLY-MODE)
    (gimp-drawable-offset layer-temp FALSE OFFSET-TRANSPARENT 0 -1)
    (gimp-image-merge-down image layer-temp 1)
    (gimp-layer-set-mode
      (car (gimp-image-get-active-drawable image))
      DARKEN-ONLY-MODE)
	(if (= flatten-image TRUE)
		(gimp-image-flatten image)
	)	  

    (gimp-image-undo-group-end image)
  )
)